#!/usr/bin/php -q
<?php

/*

Paolo Furieri furieri@ntc.it NETCOM-REG - 22.09.2010
Modifiche per EPP 2.0 04.07.2012

script php che esegue il controllo della coda di polling:
effettua il login sul server EPP del registro, interroga la coda,
se ci sono messaggi non letti invia una mail.
NON effettua la lettura del messaggio in coda.

lanciabile direttamente da riga di comando, puo' essere inserito nel crontab

ad es. su redhat, una volta variati i 3 dati di configurazione subito sotto,
basta renderlo eseguibile, e copiarlo su /etc/cron.daily

*/

function inviaricevi($xml) {
global $DEBUG;
global $eppsock;
global $inizio, $epp_SESSIONID;
global $eppserver;

$datascrittura = date("Y-m-d H:i:s");
$eppsock=fsockopen("ssl://$eppserver",443,$errno,$errstr,60);
$cmd = 
'POST / HTTP/1.1
Host: epp.nic.it
';
if ($epp_SESSIONID) 
 $cmd .= "Cookie: $epp_SESSIONID\r\n";
$cmd .=
'Referer: EPP Client Test
Content-type: application/x-www-form-urlencoded
Content-length: '.strlen($xml).'
Connection: close

' .  $xml;
fputs($eppsock,$cmd);

  $cnt=0;
  $xmlread="";
  while ((!feof($eppsock))&&($cnt<100)){
   $xmlreadslice = fread($eppsock,1024);
   $xmlread.=$xmlreadslice;
   $cnt++;
  }
fclose($eppsock);

if ($DEBUG) {
	$debug = fopen("/var/log/epp_debug.log","a");
	fputs($debug,$datascrittura ." scritto $cmd\n\n\n");
	fputs($debug,date("Y-m-d H:i:s") ." letto $xmlread\n\n\n");
	fclose($debug);
}

return($xmlread);
}

$sigla = "XXXXXX-REG";
$password = "XXXXXXX";
$eppserver="epp.nic.it";
$mydb="xxxxx";
$myus="xxxxx";
$myps="xxxxx";



$email = "xxxxxxx@xxx.it";

$DEBUG = 1;

// FINE CONFIGURAZIONE; la parte sotto non richiede modifiche

$errore = "";

header("Content-Type: text/plain");

$xml_login='<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0">
<command>
<login>
<clID>'.$sigla.'</clID>
<pw>'.$password.'</pw>
<options>
<version>1.0</version>
<lang>en</lang>
</options>
<svcs>
<objURI>urn:ietf:params:xml:ns:contact-1.0</objURI>
<objURI>urn:ietf:params:xml:ns:domain-1.0</objURI>
<svcExtension>
<extURI>http://www.nic.it/ITNIC-EPP/extepp-2.0</extURI>
<extURI>http://www.nic.it/ITNIC-EPP/extcon-1.0</extURI>
<extURI>http://www.nic.it/ITNIC-EPP/extdom-2.0</extURI>
<extURI>urn:ietf:params:xml:ns:rgp-1.0</extURI>
</svcExtension>
</svcs>
</login>
</command>
</epp>';

$xml_logout='<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:ietf:params:xml:ns:epp-1.0 epp-1.0.xsd">
<command>
<logout/>
<clTRID>xxxxxxx-xxxxxxx</clTRID>
</command>
</epp>';

$xml_pollreq='<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:ietf:params:xml:ns:epp-1.0 epp-1.0.xsd">
<command>
<poll op="req"/>
<clTRID>xxxxxxx-xxxxxxx</clTRID>
</command>
</epp>';

$xml_pollack='<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0">
<command>
<poll op="ack" msgID="[MSGID]"/>
<clTRID>xxxxxxx-xxxxxxx</clTRID>
</command>
</epp>';

$xml_infodomain='<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:ietf:params:xml:ns:epp-1.0 epp-1.0.xsd">
<command>
<info>
<domain:info xmlns:domain="urn:ietf:params:xml:ns:domain-1.0" xsi:schemaLocation="urn:ietf:params:xml:ns:domain-1.0 domain-1.0.xsd">
<domain:name hosts="all">[DOMAIN]</domain:name>
</domain:info>
</info>
<clTRID>xxxxxxx-xxxxxxx</clTRID>
</command>
</epp>';

$messaggio = "";

if(!mysql_connect('localhost',$myus,$myps))
        $errore .= "\nerrore su connessione al database $myus $myps";
if (!$errore && !mysql_select_db($mydb))
        $errore .= "\nerrore su selezione del database";

if ($errore) {
	echo "$errore\n";
	exit;
}

// ritrovo data ultimo report
$richiesta = "select * from lastreport";
$query=mysql_query($richiesta);
$row=mysql_fetch_row($query);
$lastreport = $row[0];
mysql_free_result($query);

// carico i record eventualmente salvati nel db messaggi
$richiesta = "select MSGID, DATETIME, MESSAGE, MSGXML from messages where datetime > '$lastreport' order by datetime";
$query=mysql_query($richiesta);
while($row=mysql_fetch_row($query)) {
	$epp_MSGID = addslashes($row[0]);
	$epp_DATETIME = addslashes($row[1]);
	$epp_MESSAGE = addslashes($row[2]);
	$epp_MSGXML = addslashes($row[3]);
	// cerco di estrarre il nome di dominio, se il messaggio lo prevede
	$epp_DOMAIN = "";
	$xx = explode('<extdom:name>',$epp_MSGXML);
	if ($xx[1] != "") {
		$yy = explode('</extdom:name>', $xx[1]);
		$epp_DOMAIN = $yy[0];
	}

	// gestisco eventuale formato "domain:"
	if ($epp_DOMAIN == "") {
		$xx = explode('<domain:name>',$epp_MSGXML);
		if ($xx[1] != "") {
			$yy = explode('</domain:name>', $xx[1]);
			$epp_DOMAIN = $yy[0];
		}
	}

	if ($epp_MESSAGE == "autoRenewPeriod is started") {
		$messaggio .= "$epp_DOMAIN: inizio grace-period\n";
	} elseif ($epp_MESSAGE == "autoRenewPeriod is expired") {
		$messaggio .= "$epp_DOMAIN: fine grace-period\n";
		// $messaggio .= "verifico nuova data scadenza $epp_DOMAIN\n";
		$xml_infodomain1 = str_replace("[DOMAIN]",$epp_DOMAIN,$xml_infodomain);
		$resp_infodomain = inviaricevi($xml_infodomain1);
		if (strstr($resp_infodomain, '<result code="1000">')) {
			$xx = explode('<domain:exDate>',$resp_infodomain);
			$yy = explode('T', $xx[1]);
			$epp_EXPIRE = $yy[0];
			$richiesta = "update domains set EXPIRE = \"$epp_EXPIRE\" where DOMAINNAME = \"$epp_DOMAIN\"";
			mysql_query($richiesta);
			$epp_ACTIONEDFLAG=1;

		}
	} else {
		if ($epp_DOMAIN != "")
			$messaggio .= "$epp_DOMAIN: ";
		$messaggio .= "Messaggio sconosciuto: $epp_MSGID - $epp_MESSAGE\n";
		// $messaggio .= "Verificare manualmente il contenuto della coda\n";
		// $halt = 1;
		// $epp_ACKFLAG=0;
	}
}
mysql_free_result($query);
$lastreport = date("Y-m-d H:i:s");
mysql_query("update lastreport set lastreport = '$lastreport'");

$resp_login = inviaricevi($xml_login);
// cerco il cookie di sessione
  $xx = explode('Set-Cookie: ',$resp_login);
  $yy = explode(';', $xx[1]);
  $epp_SESSIONID = $yy[0];
// cerco il credito
$xx = explode('<extepp:credit>',$resp_login);
$yy = explode('</extepp:credit>', $xx[1]);
$epp_CREDITO = $yy[0];

$resp_req = inviaricevi($xml_pollreq);
$maxconta = 100;
$conta = 0;
$halt = 0;

while ($halt == 0 && $conta++ < $maxconta && !strstr($resp_req, '<result code="1300">')) {

	$xx = explode('<msgQ ',$resp_req);
	for ($i=1;$i<count($xx);$i++) {
		if (substr($xx[$i],0,3) == 'id=') {
			$yy = explode('id="', $xx[$i]);
			$zz = explode('"', $yy[1]);
			$epp_MSGID = addslashes($zz[0]);
		}
	}

	$xx = explode('<qDate>',$resp_req);
	$yy = explode('+', $xx[1]);
	$epp_DATETIME = str_replace("T"," ",$yy[0]);

	$xx = explode('<msgQ ',$resp_req);
	$yy = explode('<msg lang="en">',$xx[1]);
	$zz = explode('</msg>', $yy[1]);
	$epp_MESSAGE = str_replace("\t"," ",addslashes($zz[0]));

	$xx = explode('<?xml ',$resp_req);
	$xx = explode('?>',$xx[1]);
	$xx = str_replace("\r",'',$xx[1]);
	while (substr($xx,-1) == "\n") { $xx = substr($xx,0,-1); }
	while (substr($xx,0,1) == "\n") { $xx = substr($xx,1); }
	$epp_MSGXML = str_replace("\t"," ",addslashes($xx));

	$epp_READFLAG=1;
	$epp_ACKFLAG=1;
	$epp_ACTIONEDFLAG=0;

	// cerco di estrarre il nome di dominio, se il messaggio lo prevede
	$epp_DOMAIN = "";
	$xx = explode('<extdom:name>',$resp_req);
	if ($xx[1] != "") {
		$yy = explode('</extdom:name>', $xx[1]);
		$epp_DOMAIN = $yy[0];
	}

	// gestisco eventuale formato "domain:"
	if ($epp_DOMAIN == "") {
		$xx = explode('<domain:name>',$resp_req);
		if ($xx[1] != "") {
			$yy = explode('</domain:name>', $xx[1]);
			$epp_DOMAIN = $yy[0];
		}
	}

	if ($epp_MESSAGE == "autoRenewPeriod is started") {
		$messaggio .= "$epp_DOMAIN: inizio grace-period\n";
	} elseif ($epp_MESSAGE == "autoRenewPeriod is expired") {
		$messaggio .= "$epp_DOMAIN: fine grace-period\n";
		// $messaggio .= "verifico nuova data scadenza $epp_DOMAIN\n";
		$xml_infodomain1 = str_replace("[DOMAIN]",$epp_DOMAIN,$xml_infodomain);
		$resp_infodomain = inviaricevi($xml_infodomain1);
		if (strstr($resp_infodomain, '<result code="1000">')) {
			$xx = explode('<domain:exDate>',$resp_infodomain);
			$yy = explode('T', $xx[1]);
			$epp_EXPIRE = $yy[0];
			$richiesta = "update domains set EXPIRE = \"$epp_EXPIRE\" where DOMAINNAME = \"$epp_DOMAIN\"";
			mysql_query($richiesta);
			$epp_ACTIONEDFLAG=1;

if ($DEBUG) {
			$debug = fopen("/var/log/epp_debug.log","a");
			fputs($debug,date("Y-m-d H:i:s") ." scritto su db: $richiesta\n\n\n");
			fclose($debug);
}
		}
	} else {
		if ($epp_DOMAIN != "")
			$messaggio .= "$epp_DOMAIN: ";
		$messaggio .= "Messaggio non gestito: $epp_MSGID - $epp_MESSAGE\n";
		// $messaggio .= "Verificare manualmente il contenuto della coda\n";
		// $halt = 1;
		// $epp_ACKFLAG=0;
	}

	if (intval($epp_MSGID) != 0) {
		$richiesta = "insert into messages (MSGID, DATETIME, MESSAGE, MSGXML, READFLAG, ACKFLAG, ACTIONEDFLAG) values(\"$epp_MSGID\", \"$epp_DATETIME\", \"$epp_MESSAGE\", \"$epp_MSGXML\",$epp_READFLAG,$epp_ACKFLAG,$epp_ACTIONEDFLAG)";
		mysql_query($richiesta);
	}

if ($DEBUG) {
	$debug = fopen("/var/log/epp_debug.log","a");
	fputs($debug,date("Y-m-d H:i:s") ." scritto su db: $richiesta\n\n\n");
	fclose($debug);
}

	if ($halt == 0) {
		// $messaggio .= "inserisco messaggio $epp_MSGID $epp_MESSAGE\n";
		$xml_pollack1 = str_replace("[MSGID]",$epp_MSGID,$xml_pollack);
		$resp_ack = inviaricevi($xml_pollack1);
		// $messaggio .= "ack di messaggio $epp_MSGID\n";
		$resp_req = inviaricevi($xml_pollreq);
	}
}

if ($conta >= $maxconta)
	$messaggio .= "elaborati $maxconta messaggi, interrompo. verifica e rilancia\n";

$numerodominii = intval($epp_CREDITO / 4.5 + 1);
$richiesta = "select expire from domains order by expire limit $numerodominii";
$query = mysql_query($richiesta);
$numerorighe = mysql_num_rows($query);
mysql_data_seek($query, $numerorighe-1);
$row=mysql_fetch_row($query);
mysql_free_result($query);

// if ($messaggio)
	mail($email, "da EPP: credito $epp_CREDITO; durevole per $numerodominii dominii, fino a $row[0]",$messaggio);

// echo "farei logout\n";
$resp_logout = inviaricevi($xml_logout);

?>
